diff --git a/src/backend/executor/nodeSpirelationscan.c b/src/backend/executor/nodeSpirelationscan.c
new file mode 100644
index 0000000..5e2c4bc
--- /dev/null
+++ b/src/backend/executor/nodeSpirelationscan.c
@@ -0,0 +1,212 @@
+/*-------------------------------------------------------------------------
+ *
+ * nodeSpirelationscan.c
+ *	  routines to handle SpiRelationScan nodes.
+ *
+ * Portions Copyright (c) 1996-2016, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  src/backend/executor/nodeSpirelationscan.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "executor/execdebug.h"
+#include "executor/nodeSpirelationscan.h"
+#include "miscadmin.h"
+
+static TupleTableSlot *SpiRelationScanNext(SpiRelationScanState *node);
+
+/* ----------------------------------------------------------------
+ *		SpiRelationScanNext
+ *
+ *		This is a workhorse for ExecSpiRelationScan
+ * ----------------------------------------------------------------
+ */
+static TupleTableSlot *
+SpiRelationScanNext(SpiRelationScanState *node)
+{
+	TupleTableSlot *slot;
+
+	/* We intentionally do not support backward scan. */
+	Assert(ScanDirectionIsForward(node->ss.ps.state->es_direction));
+
+	/*
+	 * Get the next tuple from tuplestore. Return NULL if no more tuples.
+	 */
+	slot = node->ss.ss_ScanTupleSlot;
+	tuplestore_select_read_pointer(node->table, node->readptr);
+	(void) tuplestore_gettupleslot(node->table, true, false, slot);
+	return slot;
+}
+
+/*
+ * SpiRelationScanRecheck -- access method routine to recheck a tuple in
+ * EvalPlanQual
+ */
+static bool
+SpiRelationScanRecheck(SpiRelationScanState *node, TupleTableSlot *slot)
+{
+	/* nothing to check */
+	return true;
+}
+
+/* ----------------------------------------------------------------
+ *		ExecSpiRelationScan(node)
+ *
+ *		Scans the tuplestore sequentially and returns the next qualifying
+ *		tuple.  We call the ExecScan() routine and pass it the appropriate
+ *		access method functions.
+ * ----------------------------------------------------------------
+ */
+TupleTableSlot *
+ExecSpiRelationScan(SpiRelationScanState *node)
+{
+	return ExecScan(&node->ss,
+					(ExecScanAccessMtd) SpiRelationScanNext,
+					(ExecScanRecheckMtd) SpiRelationScanRecheck);
+}
+
+
+/* ----------------------------------------------------------------
+ *		ExecInitSpiRelationScan
+ * ----------------------------------------------------------------
+ */
+SpiRelationScanState *
+ExecInitSpiRelationScan(SpiRelationScan *node, EState *estate, int eflags)
+{
+	SpiRelationScanState *scanstate;
+	ListCell *lc;
+
+	/* check for unsupported flags */
+	Assert(!(eflags & (EXEC_FLAG_BACKWARD | EXEC_FLAG_MARK)));
+
+	/*
+	 * SpiRelationScan should not have any children.
+	 */
+	Assert(outerPlan(node) == NULL);
+	Assert(innerPlan(node) == NULL);
+
+	/*
+	 * create new SpiRelationScanState for node
+	 */
+	scanstate = makeNode(SpiRelationScanState);
+	scanstate->ss.ps.plan = (Plan *) node;
+	scanstate->ss.ps.state = estate;
+
+	/* Find the SpiRelation by name to get the tuplestore + TupleDesc. */
+	foreach (lc, estate->es_spi_relations)
+	{
+		SpiRelation *sr = (SpiRelation *) lfirst(lc);
+
+		if (strcmp(sr->name, node->srname) == 0)
+		{
+			scanstate->table = sr->tuplestore;
+			scanstate->tupdesc = sr->tupdesc;
+			break;
+		}
+	}
+
+	/*
+	 * We could fail to find it if you planned a query and then tried to run
+	 * it when the SPI relation was no longer registered.
+	 */
+	if (scanstate->table == NULL)
+		elog(ERROR, "cannot find SPI relation \"%s\"", node->srname);
+
+	scanstate->readptr = tuplestore_alloc_read_pointer(scanstate->table,
+													   EXEC_FLAG_REWIND);
+
+	tuplestore_select_read_pointer(scanstate->table, scanstate->readptr);
+
+	/*
+	 * The new read pointer copies its position from read pointer 0, which
+	 * could be anywhere, so explicitly rewind it.
+	 */
+	tuplestore_rescan(scanstate->table);
+
+	/*
+	 * Miscellaneous initialization
+	 *
+	 * create expression context for node
+	 */
+	ExecAssignExprContext(estate, &scanstate->ss.ps);
+
+	/*
+	 * initialize child expressions
+	 */
+	scanstate->ss.ps.targetlist = (List *)
+		ExecInitExpr((Expr *) node->scan.plan.targetlist,
+					 (PlanState *) scanstate);
+	scanstate->ss.ps.qual = (List *)
+		ExecInitExpr((Expr *) node->scan.plan.qual,
+					 (PlanState *) scanstate);
+
+	/*
+	 * tuple table initialization
+	 */
+	ExecInitResultTupleSlot(estate, &scanstate->ss.ps);
+	ExecInitScanTupleSlot(estate, &scanstate->ss);
+
+	/*
+	 * The scan tuple type is specified for the tuplestore.
+	 */
+	ExecAssignScanType(&scanstate->ss, scanstate->tupdesc);
+
+	/*
+	 * Initialize result tuple type and projection info.
+	 */
+	ExecAssignResultTypeFromTL(&scanstate->ss.ps);
+	ExecAssignScanProjectionInfo(&scanstate->ss);
+
+	scanstate->ss.ps.ps_TupFromTlist = false;
+
+	return scanstate;
+}
+
+/* ----------------------------------------------------------------
+ *		ExecEndSpiRelationScan
+ *
+ *		frees any storage allocated through C routines.
+ * ----------------------------------------------------------------
+ */
+void
+ExecEndSpiRelationScan(SpiRelationScanState *node)
+{
+	/*
+	 * Free exprcontext
+	 */
+	ExecFreeExprContext(&node->ss.ps);
+
+	/*
+	 * clean out the tuple table
+	 */
+	ExecClearTuple(node->ss.ps.ps_ResultTupleSlot);
+	ExecClearTuple(node->ss.ss_ScanTupleSlot);
+}
+
+/* ----------------------------------------------------------------
+ *		ExecReScanSpiRelationScan
+ *
+ *		Rescans the relation.
+ * ----------------------------------------------------------------
+ */
+void
+ExecReScanSpiRelationScan(SpiRelationScanState *node)
+{
+	Tuplestorestate *tuplestorestate = node->table;
+
+	ExecClearTuple(node->ss.ps.ps_ResultTupleSlot);
+
+	ExecScanReScan(&node->ss);
+
+	/*
+	 * Rewind my own pointer.
+	 */
+	tuplestore_select_read_pointer(tuplestorestate, node->readptr);
+	tuplestore_rescan(tuplestorestate);
+}
diff --git a/src/backend/executor/spi.c b/src/backend/executor/spi.c
index 80fc4c4..d465c9d 100644
--- a/src/backend/executor/spi.c
+++ b/src/backend/executor/spi.c
@@ -122,6 +122,7 @@ SPI_connect(void)
 	_SPI_current->procCxt = NULL;		/* in case we fail to create 'em */
 	_SPI_current->execCxt = NULL;
 	_SPI_current->connectSubid = GetCurrentSubTransactionId();
+	_SPI_current->queryEnv = NULL;
 
 	/*
 	 * Create memory contexts for this procedure
@@ -1307,6 +1308,9 @@ SPI_cursor_open_internal(const char *name, SPIPlanPtr plan,
 		MemoryContextSwitchTo(oldcontext);
 	}
 
+	/* Make the SPI connection's QueryEnvironment visible to this portal. */
+	portal->queryEnv = _SPI_current->queryEnv;
+
 	/*
 	 * Start portal execution.
 	 */
@@ -1532,6 +1536,10 @@ SPI_result_code_string(int code)
 			return "SPI_ERROR_NOOUTFUNC";
 		case SPI_ERROR_TYPUNKNOWN:
 			return "SPI_ERROR_TYPUNKNOWN";
+		case SPI_ERROR_DUPLICATE:
+			return "SPI_ERROR_DUPLICATE";
+		case SPI_ERROR_NOT_FOUND:
+			return "SPI_ERROR_NOT_FOUND";
 		case SPI_OK_CONNECT:
 			return "SPI_OK_CONNECT";
 		case SPI_OK_FINISH:
@@ -1560,6 +1568,10 @@ SPI_result_code_string(int code)
 			return "SPI_OK_UPDATE_RETURNING";
 		case SPI_OK_REWRITTEN:
 			return "SPI_OK_REWRITTEN";
+		case SPI_OK_REGISTER:
+			return "SPI_OK_REGISTER";
+		case SPI_OK_UNREGISTER:
+			return "SPI_OK_UNREGISTER";
 	}
 	/* Unrecognized code ... return something useful ... */
 	sprintf(buf, "Unrecognized SPI code %d", code);
@@ -1779,14 +1791,16 @@ _SPI_prepare_plan(const char *src, SPIPlanPtr plan)
 			stmt_list = pg_analyze_and_rewrite_params(parsetree,
 													  src,
 													  plan->parserSetup,
-													  plan->parserSetupArg);
+													  plan->parserSetupArg,
+													  _SPI_current->queryEnv);
 		}
 		else
 		{
 			stmt_list = pg_analyze_and_rewrite(parsetree,
 											   src,
 											   plan->argtypes,
-											   plan->nargs);
+											   plan->nargs,
+											   _SPI_current->queryEnv);
 		}
 
 		/* Finish filling in the CachedPlanSource */
@@ -1975,14 +1989,16 @@ _SPI_execute_plan(SPIPlanPtr plan, ParamListInfo paramLI,
 				stmt_list = pg_analyze_and_rewrite_params(parsetree,
 														  src,
 														  plan->parserSetup,
-													   plan->parserSetupArg);
+													   plan->parserSetupArg,
+														  _SPI_current->queryEnv);
 			}
 			else
 			{
 				stmt_list = pg_analyze_and_rewrite(parsetree,
 												   src,
 												   plan->argtypes,
-												   plan->nargs);
+												   plan->nargs,
+												   _SPI_current->queryEnv);
 			}
 
 			/* Finish filling in the CachedPlanSource */
@@ -2089,7 +2105,9 @@ _SPI_execute_plan(SPIPlanPtr plan, ParamListInfo paramLI,
 										plansource->query_string,
 										snap, crosscheck_snapshot,
 										dest,
-										paramLI, 0);
+										paramLI,
+										_SPI_current->queryEnv,
+										0);
 				res = _SPI_pquery(qdesc, fire_triggers,
 								  canSetTag ? tcount : 0);
 				FreeQueryDesc(qdesc);
@@ -2102,6 +2120,7 @@ _SPI_execute_plan(SPIPlanPtr plan, ParamListInfo paramLI,
 							   plansource->query_string,
 							   PROCESS_UTILITY_QUERY,
 							   paramLI,
+							   _SPI_current->queryEnv,
 							   dest,
 							   completionTag);
 
@@ -2628,3 +2647,105 @@ _SPI_save_plan(SPIPlanPtr plan)
 
 	return newplan;
 }
+
+/*
+ * Register a named tuplestore for use by the planner and executor on
+ * subsequent calls using this SPI connection.
+ */
+int
+SPI_register_relation(const char *name, TupleDesc tupdesc,
+					  int tuples, Tuplestorestate *tuplestore)
+{
+	MemoryContext oldcxt;
+	SpiRelation *sr = NULL;
+	ListCell *lc;
+	int res;
+
+	if (name == NULL || tupdesc == NULL || tuplestore == NULL)
+		return SPI_ERROR_ARGUMENT;
+
+	/* Make sure we are connected. */
+	res = _SPI_begin_call(false);
+	if (res < 0)
+		return res;
+
+	/* Use procedure-duration memory for QueryEnvironment and contents. */
+	oldcxt = _SPI_procmem();
+
+	/* Create a QueryEnvironment if we don't have one already. */
+	if (_SPI_current->queryEnv == NULL)
+		_SPI_current->queryEnv =
+			(QueryEnvironment *) palloc0(sizeof(QueryEnvironment));
+
+	/* Check if this name is already registered. */
+	foreach(lc, _SPI_current->queryEnv->spi_relations)
+	{
+		sr = (SpiRelation *) lfirst(lc);
+
+		if (strcmp(sr->name, name) == 0)
+			break;
+		sr = NULL;
+	}
+
+	/* Register if we didn't find it. */
+	if (sr == NULL)
+	{
+		sr = (SpiRelation *) palloc0(sizeof(SpiRelation));
+		sr->name = pstrdup(name);
+		sr->tupdesc = CreateTupleDescCopy(tupdesc);
+		sr->tuples = tuples;
+		sr->tuplestore = tuplestore;
+		_SPI_current->queryEnv->spi_relations =
+			lappend(_SPI_current->queryEnv->spi_relations, sr);
+		res = SPI_OK_REGISTER;
+	}
+	else
+		res = SPI_ERROR_DUPLICATE;
+
+	_SPI_end_call(false);
+
+	MemoryContextSwitchTo(oldcxt);
+
+	return res;
+}
+
+/*
+ *  Unregister a named tuplestore by name.  This will probably be a rarely used
+ * function, since SPI_finish will clear it automatically.
+ */
+int
+SPI_unregister_relation(const char *name)
+{
+	ListCell *prev = NULL;
+	ListCell *lc;
+	int res = SPI_ERROR_NOT_FOUND;
+
+	/* Make sure we are connected. */
+	res = _SPI_begin_call(false);
+	if (res < 0)
+		return res;
+
+	/* Search for the relation by name. */
+	if (_SPI_current->queryEnv != NULL)
+	{
+		foreach (lc, _SPI_current->queryEnv->spi_relations)
+		{
+			SpiRelation *sr;
+
+			sr = (SpiRelation *) lfirst(lc);
+			if (strcmp(sr->name, name) == 0)
+			{
+				_SPI_current->queryEnv->spi_relations =
+					list_delete_cell(_SPI_current->queryEnv->spi_relations,
+									 lc, prev);
+				res = SPI_OK_UNREGISTER;
+				break;
+			}
+			prev = lc;
+		}
+	}
+
+	_SPI_end_call(false);
+
+	return res;
+}
diff --git a/src/backend/nodes/copyfuncs.c b/src/backend/nodes/copyfuncs.c
index 04e49b7..04dfb81 100644
--- a/src/backend/nodes/copyfuncs.c
+++ b/src/backend/nodes/copyfuncs.c
@@ -613,6 +613,27 @@ _copyCteScan(const CteScan *from)
 }
 
 /*
+ * _copySpiRelationScan
+ */
+static SpiRelationScan *
+_copySpiRelationScan(const SpiRelationScan *from)
+{
+	SpiRelationScan    *newnode = makeNode(SpiRelationScan);
+
+	/*
+	 * copy node superclass fields
+	 */
+	CopyScanFields((const Scan *) from, (Scan *) newnode);
+
+	/*
+	 * copy remainder of node
+	 */
+	COPY_STRING_FIELD(srname);
+
+	return newnode;
+}
+
+/*
  * _copyWorkTableScan
  */
 static WorkTableScan *
@@ -2156,6 +2177,7 @@ _copyRangeTblEntry(const RangeTblEntry *from)
 	COPY_NODE_FIELD(ctecoltypes);
 	COPY_NODE_FIELD(ctecoltypmods);
 	COPY_NODE_FIELD(ctecolcollations);
+	COPY_STRING_FIELD(srname);
 	COPY_NODE_FIELD(alias);
 	COPY_NODE_FIELD(eref);
 	COPY_SCALAR_FIELD(lateral);
@@ -4389,6 +4411,9 @@ copyObject(const void *from)
 		case T_CteScan:
 			retval = _copyCteScan(from);
 			break;
+		case T_SpiRelationScan:
+			retval = _copySpiRelationScan(from);
+			break;
 		case T_WorkTableScan:
 			retval = _copyWorkTableScan(from);
 			break;
diff --git a/src/backend/nodes/nodeFuncs.c b/src/backend/nodes/nodeFuncs.c
index 3997441..b4a25c9 100644
--- a/src/backend/nodes/nodeFuncs.c
+++ b/src/backend/nodes/nodeFuncs.c
@@ -2302,6 +2302,7 @@ range_table_walker(List *rtable,
 					return true;
 				break;
 			case RTE_CTE:
+			case RTE_SPIRELATION:
 				/* nothing to do */
 				break;
 			case RTE_SUBQUERY:
@@ -3098,6 +3099,7 @@ range_table_mutator(List *rtable,
 				/* we don't bother to copy eref, aliases, etc; OK? */
 				break;
 			case RTE_CTE:
+			case RTE_SPIRELATION:
 				/* nothing to do */
 				break;
 			case RTE_SUBQUERY:
diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
index 748b687..9e923ae 100644
--- a/src/backend/nodes/outfuncs.c
+++ b/src/backend/nodes/outfuncs.c
@@ -577,6 +577,16 @@ _outCteScan(StringInfo str, const CteScan *node)
 }
 
 static void
+_outSpiRelationScan(StringInfo str, const SpiRelationScan *node)
+{
+	WRITE_NODE_TYPE("SPIRELATIONSCAN");
+
+	_outScanInfo(str, (const Scan *) node);
+
+	WRITE_STRING_FIELD(srname);
+}
+
+static void
 _outWorkTableScan(StringInfo str, const WorkTableScan *node)
 {
 	WRITE_NODE_TYPE("WORKTABLESCAN");
@@ -2849,6 +2859,13 @@ _outRangeTblEntry(StringInfo str, const RangeTblEntry *node)
 			WRITE_NODE_FIELD(ctecoltypmods);
 			WRITE_NODE_FIELD(ctecolcollations);
 			break;
+		case RTE_SPIRELATION:
+			WRITE_STRING_FIELD(srname);
+			WRITE_OID_FIELD(relid);
+			WRITE_NODE_FIELD(ctecoltypes);
+			WRITE_NODE_FIELD(ctecoltypmods);
+			WRITE_NODE_FIELD(ctecolcollations);
+			break;
 		default:
 			elog(ERROR, "unrecognized RTE kind: %d", (int) node->rtekind);
 			break;
@@ -3368,6 +3385,9 @@ outNode(StringInfo str, const void *obj)
 			case T_CteScan:
 				_outCteScan(str, obj);
 				break;
+			case T_SpiRelationScan:
+				_outSpiRelationScan(str, obj);
+				break;
 			case T_WorkTableScan:
 				_outWorkTableScan(str, obj);
 				break;
diff --git a/src/backend/nodes/print.c b/src/backend/nodes/print.c
index a1f2941..53a6164 100644
--- a/src/backend/nodes/print.c
+++ b/src/backend/nodes/print.c
@@ -287,6 +287,10 @@ print_rt(const List *rtable)
 				printf("%d\t%s\t[cte]",
 					   i, rte->eref->aliasname);
 				break;
+			case RTE_SPIRELATION:
+				printf("%d\t%s\t[spirelation]",
+					   i, rte->eref->aliasname);
+				break;
 			default:
 				printf("%d\t%s\t[unknown rtekind]",
 					   i, rte->eref->aliasname);
diff --git a/src/backend/nodes/readfuncs.c b/src/backend/nodes/readfuncs.c
index 917e6c8..3eca76f 100644
--- a/src/backend/nodes/readfuncs.c
+++ b/src/backend/nodes/readfuncs.c
@@ -1324,6 +1324,13 @@ _readRangeTblEntry(void)
 			READ_NODE_FIELD(ctecoltypmods);
 			READ_NODE_FIELD(ctecolcollations);
 			break;
+		case RTE_SPIRELATION:
+			READ_STRING_FIELD(srname);
+			READ_OID_FIELD(relid);
+			READ_NODE_FIELD(ctecoltypes);
+			READ_NODE_FIELD(ctecoltypmods);
+			READ_NODE_FIELD(ctecolcollations);
+			break;
 		default:
 			elog(ERROR, "unrecognized RTE kind: %d",
 				 (int) local_node->rtekind);
diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index e42ef98..6e9b112 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -107,6 +107,8 @@ static void set_values_pathlist(PlannerInfo *root, RelOptInfo *rel,
 					RangeTblEntry *rte);
 static void set_cte_pathlist(PlannerInfo *root, RelOptInfo *rel,
 				 RangeTblEntry *rte);
+static void set_spirelation_pathlist(PlannerInfo *root, RelOptInfo *rel,
+				 RangeTblEntry *rte);
 static void set_worktable_pathlist(PlannerInfo *root, RelOptInfo *rel,
 					   RangeTblEntry *rte);
 static RelOptInfo *make_rel_from_joinlist(PlannerInfo *root, List *joinlist);
@@ -379,6 +381,9 @@ set_rel_size(PlannerInfo *root, RelOptInfo *rel,
 				else
 					set_cte_pathlist(root, rel, rte);
 				break;
+			case RTE_SPIRELATION:
+				set_spirelation_pathlist(root, rel, rte);
+				break;
 			default:
 				elog(ERROR, "unexpected rtekind: %d", (int) rel->rtekind);
 				break;
@@ -443,6 +448,9 @@ set_rel_pathlist(PlannerInfo *root, RelOptInfo *rel,
 			case RTE_CTE:
 				/* CTE reference --- fully handled during set_rel_size */
 				break;
+			case RTE_SPIRELATION:
+				/* SPI relation reference --- fully handled during set_rel_size */
+				break;
 			default:
 				elog(ERROR, "unexpected rtekind: %d", (int) rel->rtekind);
 				break;
@@ -614,6 +622,13 @@ set_rel_consider_parallel(PlannerInfo *root, RelOptInfo *rel,
 			 * executed only once.
 			 */
 			return;
+
+		case RTE_SPIRELATION:
+			/*
+			 * SPI relation tuplestores cannot be shared, at least without
+			 * more infrastructure to support that.
+			 */
+			return;
 	}
 
 	/*
@@ -1948,6 +1963,35 @@ set_cte_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 }
 
 /*
+ * set_spirelation_pathlist
+ *		Build the (single) access path for an SPI relation RTE
+ *
+ * There's no need for a separate set_spirelation_size phase, since we don't
+ * support join-qual-parameterized paths for SPI relations.
+ */
+static void
+set_spirelation_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
+{
+	Relids		required_outer;
+
+	/* Mark rel with estimated output rows, width, etc */
+	set_spirelation_size_estimates(root, rel);
+
+	/*
+	 * We don't support pushing join clauses into the quals of an SPI relation
+	 * scan, but it could still have required parameterization due to LATERAL
+	 * refs in its tlist.
+	 */
+	required_outer = rel->lateral_relids;
+
+	/* Generate appropriate path */
+	add_path(rel, create_spirelationscan_path(root, rel, required_outer));
+
+	/* Select cheapest path (pretty easy in this case...) */
+	set_cheapest(rel);
+}
+
+/*
  * set_worktable_pathlist
  *		Build the (single) access path for a self-reference CTE RTE
  *
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index e42895d..680e383 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -1383,6 +1383,44 @@ cost_ctescan(Path *path, PlannerInfo *root,
 }
 
 /*
+ * cost_spirelationscan
+ *	  Determines and returns the cost of scanning a tuplestore supplied
+ *	  by SPI client code.
+ */
+void
+cost_spirelationscan(Path *path, PlannerInfo *root,
+					 RelOptInfo *baserel, ParamPathInfo *param_info)
+{
+	Cost		startup_cost = 0;
+	Cost		run_cost = 0;
+	QualCost	qpqual_cost;
+	Cost		cpu_per_tuple;
+
+	/* Should only be applied to base relations that are SPI relations */
+	Assert(baserel->relid > 0);
+	Assert(baserel->rtekind == RTE_SPIRELATION);
+
+	/* Mark the path with the correct row estimate */
+	if (param_info)
+		path->rows = param_info->ppi_rows;
+	else
+		path->rows = baserel->rows;
+
+	/* Charge one CPU tuple cost per row for tuplestore manipulation */
+	cpu_per_tuple = cpu_tuple_cost;
+
+	/* Add scanning CPU costs */
+	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
+
+	startup_cost += qpqual_cost.startup;
+	cpu_per_tuple += cpu_tuple_cost + qpqual_cost.per_tuple;
+	run_cost += cpu_per_tuple * baserel->tuples;
+
+	path->startup_cost = startup_cost;
+	path->total_cost = startup_cost + run_cost;
+}
+
+/*
  * cost_recursive_union
  *	  Determines and returns the cost of performing a recursive union,
  *	  and also the estimated output size.
@@ -4463,6 +4501,38 @@ set_cte_size_estimates(PlannerInfo *root, RelOptInfo *rel, double cte_rows)
 }
 
 /*
+ * set_spirelation_size_estimates
+ *		Set the size estimates for a base relation that is a SPI relation
+ *		reference.
+ *
+ * The rel's targetlist and restrictinfo list must have been constructed
+ * already.
+ *
+ * We set the same fields as set_baserel_size_estimates.
+ */
+void
+set_spirelation_size_estimates(PlannerInfo *root, RelOptInfo *rel)
+{
+	RangeTblEntry *rte;
+
+	/* Should only be applied to base relations that are SPI relation refs */
+	Assert(rel->relid > 0);
+	rte = planner_rt_fetch(rel->relid, root);
+	Assert(rte->rtekind == RTE_SPIRELATION);
+
+	/*
+	 * Use the esimate provided by the SPI client that provided this SPI
+	 * relation.  We could instead ask the tuplestore, but since the resulting
+	 * plan may be reused for later queries, it seems better to let the user
+	 * control the estimate.
+	 */
+	rel->tuples = rte->srtuples;
+
+	/* Now estimate number of output rows, etc */
+	set_baserel_size_estimates(root, rel);
+}
+
+/*
  * set_foreign_size_estimates
  *		Set the size estimates for a base relation that is a foreign table.
  *
diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index ad49674..7c94e21 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -135,6 +135,8 @@ static ValuesScan *create_valuesscan_plan(PlannerInfo *root, Path *best_path,
 					   List *tlist, List *scan_clauses);
 static CteScan *create_ctescan_plan(PlannerInfo *root, Path *best_path,
 					List *tlist, List *scan_clauses);
+static SpiRelationScan *create_spirelationscan_plan(PlannerInfo *root, Path *best_path,
+					List *tlist, List *scan_clauses);
 static WorkTableScan *create_worktablescan_plan(PlannerInfo *root, Path *best_path,
 						  List *tlist, List *scan_clauses);
 static ForeignScan *create_foreignscan_plan(PlannerInfo *root, ForeignPath *best_path,
@@ -191,6 +193,8 @@ static ValuesScan *make_valuesscan(List *qptlist, List *qpqual,
 				Index scanrelid, List *values_lists);
 static CteScan *make_ctescan(List *qptlist, List *qpqual,
 			 Index scanrelid, int ctePlanId, int cteParam);
+static SpiRelationScan *make_spirelationscan(List *qptlist, List *qpqual,
+			 Index scanrelid, char *srname);
 static WorkTableScan *make_worktablescan(List *qptlist, List *qpqual,
 				   Index scanrelid, int wtParam);
 static Append *make_append(List *appendplans, List *tlist);
@@ -356,6 +360,7 @@ create_plan_recurse(PlannerInfo *root, Path *best_path, int flags)
 		case T_ValuesScan:
 		case T_CteScan:
 		case T_WorkTableScan:
+		case T_SpiRelationScan:
 		case T_ForeignScan:
 		case T_CustomScan:
 			plan = create_scan_plan(root, best_path, flags);
@@ -644,6 +649,13 @@ create_scan_plan(PlannerInfo *root, Path *best_path, int flags)
 												scan_clauses);
 			break;
 
+		case T_SpiRelationScan:
+			plan = (Plan *) create_spirelationscan_plan(root,
+														best_path,
+														tlist,
+														scan_clauses);
+			break;
+
 		case T_WorkTableScan:
 			plan = (Plan *) create_worktablescan_plan(root,
 													  best_path,
@@ -3124,6 +3136,45 @@ create_ctescan_plan(PlannerInfo *root, Path *best_path,
 }
 
 /*
+ * create_spirelationscan_plan
+ *	 Returns an SpiRelationScan plan for the base relation scanned by
+ *	'best_path' with restriction clauses 'scan_clauses' and targetlist
+ *	'tlist'.
+ */
+static SpiRelationScan *
+create_spirelationscan_plan(PlannerInfo *root, Path *best_path,
+							List *tlist, List *scan_clauses)
+{
+	SpiRelationScan *scan_plan;
+	Index		scan_relid = best_path->parent->relid;
+	RangeTblEntry *rte;
+
+	Assert(scan_relid > 0);
+	rte = planner_rt_fetch(scan_relid, root);
+	Assert(rte->rtekind == RTE_SPIRELATION);
+
+	/* Sort clauses into best execution order */
+	scan_clauses = order_qual_clauses(root, scan_clauses);
+
+	/* Reduce RestrictInfo list to bare expressions; ignore pseudoconstants */
+	scan_clauses = extract_actual_clauses(scan_clauses, false);
+
+	/* Replace any outer-relation variables with nestloop params */
+	if (best_path->param_info)
+	{
+		scan_clauses = (List *)
+			replace_nestloop_params(root, (Node *) scan_clauses);
+	}
+
+	scan_plan = make_spirelationscan(tlist, scan_clauses, scan_relid,
+									 rte->srname);
+
+	copy_generic_path_info(&scan_plan->scan.plan, best_path);
+
+	return scan_plan;
+}
+
+/*
  * create_worktablescan_plan
  *	 Returns a worktablescan plan for the base relation scanned by 'best_path'
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
@@ -4887,6 +4938,26 @@ make_ctescan(List *qptlist,
 	return node;
 }
 
+static SpiRelationScan *
+make_spirelationscan(List *qptlist,
+					 List *qpqual,
+					 Index scanrelid,
+					 char *srname)
+{
+	SpiRelationScan *node = makeNode(SpiRelationScan);
+	Plan	   *plan = &node->scan.plan;
+
+	/* cost should be inserted by caller */
+	plan->targetlist = qptlist;
+	plan->qual = qpqual;
+	plan->lefttree = NULL;
+	plan->righttree = NULL;
+	node->scan.scanrelid = scanrelid;
+	node->srname = srname;
+
+	return node;
+}
+
 static WorkTableScan *
 make_worktablescan(List *qptlist,
 				   List *qpqual,
diff --git a/src/backend/optimizer/plan/setrefs.c b/src/backend/optimizer/plan/setrefs.c
index d91bc3b..935af31 100644
--- a/src/backend/optimizer/plan/setrefs.c
+++ b/src/backend/optimizer/plan/setrefs.c
@@ -580,6 +580,17 @@ set_plan_refs(PlannerInfo *root, Plan *plan, int rtoffset)
 					fix_scan_list(root, splan->scan.plan.qual, rtoffset);
 			}
 			break;
+		case T_SpiRelationScan:
+			{
+				SpiRelationScan *splan = (SpiRelationScan *) plan;
+
+				splan->scan.scanrelid += rtoffset;
+				splan->scan.plan.targetlist =
+					fix_scan_list(root, splan->scan.plan.targetlist, rtoffset);
+				splan->scan.plan.qual =
+					fix_scan_list(root, splan->scan.plan.qual, rtoffset);
+			}
+			break;
 		case T_WorkTableScan:
 			{
 				WorkTableScan *splan = (WorkTableScan *) plan;
diff --git a/src/backend/optimizer/plan/subselect.c b/src/backend/optimizer/plan/subselect.c
index 263ba45..bd51c7b 100644
--- a/src/backend/optimizer/plan/subselect.c
+++ b/src/backend/optimizer/plan/subselect.c
@@ -2459,6 +2459,10 @@ finalize_plan(PlannerInfo *root, Plan *plan, Bitmapset *valid_params,
 			context.paramids = bms_add_members(context.paramids, scan_params);
 			break;
 
+		case T_SpiRelationScan:
+			context.paramids = bms_add_members(context.paramids, scan_params);
+			break;
+
 		case T_ForeignScan:
 			{
 				ForeignScan *fscan = (ForeignScan *) plan;
diff --git a/src/backend/optimizer/prep/prepjointree.c b/src/backend/optimizer/prep/prepjointree.c
index b681230..114c319 100644
--- a/src/backend/optimizer/prep/prepjointree.c
+++ b/src/backend/optimizer/prep/prepjointree.c
@@ -1121,6 +1121,7 @@ pull_up_simple_subquery(PlannerInfo *root, Node *jtnode, RangeTblEntry *rte,
 					break;
 				case RTE_JOIN:
 				case RTE_CTE:
+				case RTE_SPIRELATION:
 					/* these can't contain any lateral references */
 					break;
 			}
@@ -1973,6 +1974,7 @@ replace_vars_in_jointree(Node *jtnode,
 						break;
 					case RTE_JOIN:
 					case RTE_CTE:
+					case RTE_SPIRELATION:
 						/* these shouldn't be marked LATERAL */
 						Assert(false);
 						break;
diff --git a/src/backend/optimizer/util/clauses.c b/src/backend/optimizer/util/clauses.c
index 1688310..8c336a2 100644
--- a/src/backend/optimizer/util/clauses.c
+++ b/src/backend/optimizer/util/clauses.c
@@ -4974,7 +4974,8 @@ inline_set_returning_function(PlannerInfo *root, RangeTblEntry *rte)
 	querytree_list = pg_analyze_and_rewrite_params(linitial(raw_parsetree_list),
 												   src,
 									   (ParserSetupHook) sql_fn_parser_setup,
-												   pinfo);
+												   pinfo,
+												   NULL);
 	if (list_length(querytree_list) != 1)
 		goto fail;
 	querytree = linitial(querytree_list);
diff --git a/src/backend/optimizer/util/pathnode.c b/src/backend/optimizer/util/pathnode.c
index 6d3ccfd..190c432 100644
--- a/src/backend/optimizer/util/pathnode.c
+++ b/src/backend/optimizer/util/pathnode.c
@@ -1805,6 +1805,31 @@ create_ctescan_path(PlannerInfo *root, RelOptInfo *rel, Relids required_outer)
 }
 
 /*
+ * create_spirelationscan_path
+ *	  Creates a path corresponding to a scan of tuples supplied by SPI code,
+ *    returning the pathnode.
+ */
+Path *
+create_spirelationscan_path(PlannerInfo *root, RelOptInfo *rel, Relids required_outer)
+{
+	Path	   *pathnode = makeNode(Path);
+
+	pathnode->pathtype = T_SpiRelationScan;
+	pathnode->parent = rel;
+	pathnode->pathtarget = rel->reltarget;
+	pathnode->param_info = get_baserel_parampathinfo(root, rel,
+													 required_outer);
+	pathnode->parallel_aware = false;
+	pathnode->parallel_safe = rel->consider_parallel;
+	pathnode->parallel_workers = 0;
+	pathnode->pathkeys = NIL;	/* result is always unordered */
+
+	cost_spirelationscan(pathnode, root, rel, pathnode->param_info);
+
+	return pathnode;
+}
+
+/*
  * create_worktablescan_path
  *	  Creates a path corresponding to a scan of a self-reference CTE,
  *	  returning the pathnode.
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
index ad07baa..f5935c1 100644
--- a/src/backend/optimizer/util/plancat.c
+++ b/src/backend/optimizer/util/plancat.c
@@ -1360,7 +1360,8 @@ relation_excluded_by_constraints(PlannerInfo *root,
  *
  * We also support building a "physical" tlist for subqueries, functions,
  * values lists, and CTEs, since the same optimization can occur in
- * SubqueryScan, FunctionScan, ValuesScan, CteScan, and WorkTableScan nodes.
+ * SubqueryScan, FunctionScan, ValuesScan, CteScan, SpiRelationScan, and
+ * WorkTableScan nodes.
  */
 List *
 build_physical_tlist(PlannerInfo *root, RelOptInfo *rel)
@@ -1434,6 +1435,7 @@ build_physical_tlist(PlannerInfo *root, RelOptInfo *rel)
 		case RTE_FUNCTION:
 		case RTE_VALUES:
 		case RTE_CTE:
+		case RTE_SPIRELATION:
 			/* Not all of these can have dropped cols, but share code anyway */
 			expandRTE(rte, varno, 0, -1, true /* include dropped */ ,
 					  NULL, &colvars);
diff --git a/src/backend/optimizer/util/relnode.c b/src/backend/optimizer/util/relnode.c
index deef560..16aadc7 100644
--- a/src/backend/optimizer/util/relnode.c
+++ b/src/backend/optimizer/util/relnode.c
@@ -149,6 +149,7 @@ build_simple_rel(PlannerInfo *root, int relid, RelOptKind reloptkind)
 		case RTE_FUNCTION:
 		case RTE_VALUES:
 		case RTE_CTE:
+		case RTE_SPIRELATION:
 
 			/*
 			 * Subquery, function, or values list --- set up attr range and
